#pragma once

#include <string>
#include <vector>
#include <set>
#include <tbb/concurrent_vector.h>


int ComparePattern(const std::string &dataSet, const std::string &pattern, int offset);
int PatternCount(const std::string &dataSet, const std::string &pattern);
tbb::concurrent_vector<int> PatternPositions(const std::string &dataSet, const std::string &pattern);
std::set<std::string> FrequentPatterns(const std::string &dataSet, int k);
std::set<std::string> FindClumps(const std::string &dataSet, int L, int k, int t);
std::string ReverseCompliment(const std::string &dataSet);
std::vector<int>MinSkews(const std::string &dataSet);
int HammingDistance(const std::string &s1, const std::string &s2);
tbb::concurrent_vector<int>ApproximatePatternPositions(const std::string &dataSet, const std::string &pattern, int minHammingDistance);
int ApproximatePatternCount(const std::string &dataSet, const std::string &pattern, int minHammingDistance);
int SymbolToNumber(char symbol);
std::string NumberToSymbol(int n);
int PatternToNumber(const std::string &pattern);
std::string NumberToPattern(int i, int k);
std::string Suffix(const std::string &pattern);
std::set<std::string> Neighbors(const std::string &pattern, int minHammingDistance);
std::set<std::string> FrequentPatternsWithMismatches(const std::string &dataSet, int k, int minHammingDistance);
std::set<std::string> FrequentPatternsRCWithMismatches(const std::string &dataSet, int k, int minHammingDistance);
