#include <iostream>
#include <fstream>
#include <sstream>
#include <vector>
#include <set>
#include <tbb/concurrent_vector.h>
#include "patternmatch.h"



 
int main(int argc, char **argv)
{
  std::string s, data, pattern;
  tbb::concurrent_vector<int> patternPositions;
  std::set<std::string> frequentPatterns, clumps;
  std::ifstream testData(argv[1]);



  // Genome data starts after the first line of file.
  std::getline(testData, s);
  for(std::string line; std::getline(testData, line);) {
    data += line;
  }

  testData.close();
    
  pattern = "cagcgccag";

  
  // PatternCount
  std::cout << "PatternCount...\n";
  std::cout << pattern << " occurs " << PatternCount(data, pattern) << " times.\n";
  

  // PatternPositions
  std::cout << "PatternPositions...\n";
  patternPositions = PatternPositions(data, pattern);
  std::cout << "patternPositions contains " << patternPositions.size() << " elements.\n";



  // FrequentPatterns
  std::cout << "FrequentPatterns...\n";
  frequentPatterns = FrequentPatterns(data, 13);
  for(auto s : frequentPatterns) {
    std::cout << s << " occurs " << PatternCount(data, s) << " times.\n";
  }
  

  // FindClumps
  /*
  clumps = FindClumps(data, 500, 9, 3);
  for(auto s : clumps) {
    std::cout << s << " occurs 3 times in a window of 500\n";
  }
  */


  // ApproximatePatternCount
  // std::cout << pattern << " occurs " << ApproximatePatternCount(data, pattern, 3) << " times with 3 mismatches\n";

  // ApproximatePatternPositions
  /*
  patternPositions.clear();
  patternPositions = ApproximatePatternPositions(data, pattern, 3);
  std::cout << "patternPositions vector contains " << patternPositions.size() << " elements\n";
  */
  /*
  for(auto i : patternPositions) {
    std::cout << pattern << " occurs at position " << i << " with 3 mismatches\n";
  }
  */

  // FrequentPatternsWithMismatches
  // frequentPatterns.empty();
  // frequentPatterns = FrequentPatternsWithMismatches(data, 9, 3);
  // std::cout << "frequentPatterns set contains " << frequentPatterns.size() << " elements\n";
  /*
  for(auto s : frequentPatterns) {
    std::cout << s << " occurs " << ApproximatePatternCount(data, s, 3) << " times with 3 mismatches\n";
  }
  */


  // FrequentPatternsRCWithMismatches (includes the reverse compliment of frequent patterns)
  // frequentPatterns.empty();
  // frequentPatterns = FrequentPatternsRCWithMismatches(data, 9, 3);
  // std::cout << "frequentPatterns set contains" << frequentPatterns.size() << " elements\n";
  /*
  for(auto s : frequentPatterns) {
    std::cout << s << " occurs " << ApproximatePatternCount(data, s, 3) << " times with 3 mismatches\n";
  }
  */

  return 0;
}
